CapacityChangeEvent = {};
CapacityChangeEvent_mt = Class(CapacityChangeEvent, Event);

InitEventClass(CapacityChangeEvent, "CapacityChangeEvent");

function CapacityChangeEvent:emptyNew()
    local self = Event:new(CapacityChangeEvent_mt);
    self.className = "CapacityChangeEvent";
    return self;
end;

function CapacityChangeEvent:new(object, changeCapacity, attachedVehicle)
    local self = CapacityChangeEvent:emptyNew()
    self.object = object;
	self.changeCapacity = changeCapacity;
	self.attachedVehicle = attachedVehicle;
    return self;
end;

function CapacityChangeEvent:readStream(streamId, connection)
    self.object = networkGetObject(streamReadInt32(streamId));
    self.changeCapacity = streamReadBool(streamId);
	self.attachedVehicle  = networkGetObject(streamReadInt32(streamId));
    self:run(connection);
end;

function CapacityChangeEvent:writeStream(streamId, connection)
    streamWriteInt32(streamId, networkGetObjectId(self.object));
    streamWriteBool(streamId, self.changeCapacity);
    streamWriteInt32(streamId, networkGetObjectId(self.attachedVehicle));
end;

function CapacityChangeEvent:run(connection)
  self.object:capacityChange(self.changeCapacity, self.attachedVehicle, true);
	if not connection:getIsServer() then
		g_server:broadcastEvent(CapacityChangeEvent:new(self.object, self.changeCapacity, self.attachedVehicle), nil, connection, self.object);
	end;
end;

function CapacityChangeEvent.sendEvent(object, changeCapacity, attachedVehicle, noEventSend)
  if noEventSend == nil or noEventSend == false then
    if g_server ~= nil then
      g_server:broadcastEvent(CapacityChangeEvent:new(object, changeCapacity, attachedVehicle), nil, nil, object);
    else
      g_client:getServerConnection():sendEvent(CapacityChangeEvent:new(object, changeCapacity, attachedVehicle));
    end;
  end;
end;

