﻿NewAnimationValuesEvent = {};
NewAnimationValuesEvent_mt = Class(NewAnimationValuesEvent, Event);

InitEventClass(NewAnimationValuesEvent, "NewAnimationValuesEvent");

function NewAnimationValuesEvent:emptyNew()
    local self = Event:new(NewAnimationValuesEvent_mt);
    self.className = "NewAnimationValuesEvent";
    return self;
end;

function NewAnimationValuesEvent:new(object, distanceSmallEnough, distanceLargeEnough)
    local self = NewAnimationValuesEvent:emptyNew()
    self.object = object;
	self.distanceSmallEnough = distanceSmallEnough;
	self.distanceLargeEnough = distanceLargeEnough;
    return self;
end;

function NewAnimationValuesEvent:readStream(streamId, connection)
    self.object = networkGetObject(streamReadInt32(streamId));
	self.distanceSmallEnough = streamReadBool(streamId);
	self.distanceLargeEnough = streamReadBool(streamId);
    self:run(connection);
end;

function NewAnimationValuesEvent:writeStream(streamId, connection)
    streamWriteInt32(streamId, networkGetObjectId(self.object));
    streamWriteBool(streamId, self.distanceSmallEnough);
    streamWriteBool(streamId, self.distanceLargeEnough);
end;

function NewAnimationValuesEvent:run(connection)
  self.object:newAnimationValues(self.distanceSmallEnough, self.distanceLargeEnough, true);
	if not connection:getIsServer() then
		g_server:broadcastEvent(NewAnimationValuesEvent:new(self.object, self.distanceSmallEnough, self.distanceLargeEnough), nil, connection, self.object);
	end;
end;

function NewAnimationValuesEvent.sendEvent(object, distanceSmallEnough, distanceLargeEnough, noEventSend)
  if noEventSend == nil or noEventSend == false then
    if g_server ~= nil then
      g_server:broadcastEvent(NewAnimationValuesEvent:new(object, distanceSmallEnough, distanceLargeEnough), nil, nil, object);
    else
      g_client:getServerConnection():sendEvent(NewAnimationValuesEvent:new(object, distanceSmallEnough, distanceLargeEnough));
    end;
  end;
end;

